// The Javascript for proper functioning of the Section Gradebook
var errorbg = "#F66";
var changedbg = "lightgreen";
var warningbg = "orange";
var defaultbg = "transparent";
var defaulttext = 'Changes are not saved as they are typed. Click "Save" to save them.';

var numstudents = <tal:block replace="python: len(view.students)"> Number of students </tal:block>;
var students = new Array(numstudents);
<tal:loop repeat="student view/students">
     students[<tal:block replace="repeat/student/index"/>] = '<tal:block replace="python: view.breakJSString(student.username)"/>';
     </tal:loop>

var numscores = <tal:block replace="python: len(view.scores)"/>;
var scores = new Array(numscores*2+1);
scores[0] = "-";
<tal:loop repeat="score view/scores">
     scores[<tal:block replace="python:(repeat['score'].number()*2)-1"/>] = '<tal:block replace="python: view.breakJSString(score.value)"/>';
     scores[<tal:block replace="python:(repeat['score'].number()*2)"/>] = '<tal:block replace="python: view.breakJSString(score.title)"/>';
</tal:loop>

var numcomps = <tal:block replace="python: len(view.comps)" />;
var comps = new Array(numcomps);
var compTitles = new Object();
compTitles['!Default!'] = 'Scroll over a competency ID to see its description here';
<tal:loop repeat="comp view/comps">
     comps[<tal:block replace="repeat/comp/index"/>] = '<tal:block replace="python: view.breakJSString(comp.globalId)"/>';
     compTitles['<tal:block replace="comp/globalId"/>'] = '<tal:block replace="python: view.breakJSString(comp.id)" />: <tal:block replace="python: view.breakJSString(comp.competency.title)"/>';
</tal:loop>


var positioned = new Boolean(false);
var edited = new Boolean(false);
var currentinput;
function setWarning(text, bg){
    document.getElementById('warningtext').innerHTML = text;
    document.getElementById('warning').style.backgroundColor = bg;
}

function performFillDown(compid) {
 var val = document.getElementById("fd"+compid).value;
 if (val=='') return;
 var invalid = new Boolean(true);
 for(var index in scores){
  if (val==scores[index]) {
   invalid = false;
   } }
 document.getElementById('fd'+compid).style.backgroundColor = defaultbg;
 if (invalid==true){
  document.getElementById('fd'+compid).style.backgroundColor = warningbg;
  setWarning('You may not apply the fill-down to an invalid grade',errorbg);
  return;}
 for(j=0;j!=numstudents;j++){
  document.getElementsByName(students[j]+"_"+compid)[0].value=val;
  checkValid(null,students[j]+"_"+compid);
 }
 document.getElementById("fd"+compid).value = "";
 document.getElementById("fd"+compid).backgroundColor = defaultbg;
 document.getElementById("fdbtn"+compid).style.display = 'none' ;
 setWarning(defaulttext,defaultbg);
}

function checkValid(e,name){
 edited = true;
 if(e!=null)
 {
    var keynum;
    if(window.event) // IE
    {
    keynum = e.keyCode;
    }
    else if(e.which) // Netscape/Firefox/Opera
    {
    keynum = e.which;
    }
    if ((keynum==13)||(keynum==37)||(keynum==38)||(keynum==39)||(keynum==40) )
    {
        document.getElementsByName(name)[0].select();
        return true;
    }
 }
 var element = document.getElementsByName(name)[0];
 var value = element.value;
 setWarning(defaulttext,defaultbg);
 for(var index in scores){
  if (value==scores[index]) {
   element.style.backgroundColor = changedbg;
   return true;} }
 element.style.backgroundColor = warningbg;
 return false;

 }

function changeGroup(){
 if (edited==true)
 {
  var want_to_change = confirm("Are you sure you want to continue? Changing competency group will lose any unsaved changes.");
  if (want_to_change==false){
   document.getElementById('default-option').selected='true';
   return;
  }
 }
 document.getElementById("form-submitted").value='no-edit-content';
 document.gradebook.submit();
}

function submitEval(){
    setWarning('Checking the form for score validity...', defaultbg);
    document.getElementById('warning').style.display='block';
    var badform = new Boolean(false);
    for (var i in students){
	for (var j in comps){
	    var name = students[i]+'_'+comps[j];
	    var element = document.getElementsByName(name)[0];
	    var value = element.value;
	    var notfound = new Boolean(true);
	    for(var k in scores){
		if (value == scores[k]) {
		    notfound = false;
		    break;
		}
	    }
	    if (notfound==true) {
		element.style.backgroundColor = errorbg;
		badform = true;
	    }
	}
    }
    if (badform==true) {
	setWarning('Some scores entered are invalid. They need to be fixed before submitting', errorbg);
	return;
    }
    else{document.gradebook.submit();}
}

function spreadsheetBehaviour(e)
{
 var keynum;
 if(window.event) // IE
 {
  keynum = e.keyCode;
 }
 else if(e.which) // Netscape/Firefox/Opera
 {
  keynum = e.which;
 }
 var my_name = currentinput.name;
 var s, c, done;
 done = new Boolean(false);
 for (s=0;s!=numstudents;s++)
 {
  for (c=0;c!=numcomps;c++)
  {
   if ((students[s]+'_'+comps[c])==my_name)
    done=true;
   if (done==true)
    break;
  }
  if (done==true)
    break;
 }
 var i_stayed_put = new Boolean(true);
 if (keynum==37) // left arrow
 {
  if (c!=0) { c--; i_stayed_put=false;}
 }
 if (keynum==39) // right arrow
 {
  if (c!=numcomps-1) {c++; i_stayed_put=false;}
 }
 if (keynum==38) // up arrow
 {
  if (s!=0) {s--; i_stayed_put=false;}
 }
 if ((keynum==40) || (keynum==13)) // down arrow or enter
 {
  if (s!=numstudents-1) {s++; i_stayed_put=false;}
 }
 if (i_stayed_put==true)
  return true;
 var newname = students[s]+"_"+comps[c];
 var el = document.getElementsByName(newname)[0]
 el.focus();
 //el.select();
 return false;
}

function checkFillDown(name)
{
 if (checkValid(null,'fd'+name))
 {
  document.getElementById('fdbtn'+name).style.display='block';
 }
 else
 {
  document.getElementById('fdbtn'+name).style.display='none';
  if (document.getElementById('fd'+name).value=='')
   document.getElementById('fd'+name).style.backgroundColor=defaultbg;
 }
}

function positionCompDescription(flag)   {

    style = document.getElementById("compDescription").style;
    style.left = (getWindowWidth() / 10) - 20 + "px";
    style.border = "thin solid black";
    setInterval("moveCompDescription()", 10);
}

function setCompDescriptionColor(flag)  {
    style = document.getElementById("compDescription").style;
    if(flag == "required-comp")  {
        style.color = "green";
    }   else if(flag == "sensitive") {
        style.color = "red";
    }   else if(flag == "additional-comp") {
        style.color = "blue";
    }   else {
        style.color = "black";
    }
}

function moveCompDescription()  {
    var step = 10;
    var scrollX = getScrollXPos() + (getWindowWidth() / 10) - 20;
    style = document.getElementById("compDescription").style;
    style.minWidth = (getWindowWidth() / 10 * 8) + "px";
    var currentX = parseInt(style.left.substring(0,style.left.length-1));
    if(currentX != scrollX)   {
        if(currentX > scrollX && Math.abs(currentX - scrollX) > step)    {
            style.left = currentX - (Math.abs(currentX - scrollX) / step) + "px";
        }  else if(currentX < scrollX && Math.abs(currentX - scrollX) > step)    {
            style.left = currentX + (Math.abs(currentX - scrollX) / step) + "px";
        }
    }
}

function getScrollXPos() {
    var scrollX = 0;
    if(typeof(window.pageXOffset) == 'number')  {
        scrollX = window.pageXOffset;
    } else if(document.body && document.body.scrollLeft) {
        scrollX = document.body.scrollLeft;
    } else if(document.documentElement && document.documentElement.scrollLeft) {
        scrollX = document.documentElement.scrollLeft;
    }
    return scrollX;
}

function getWindowWidth()   {
    var width = 0;
    if(typeof(window.innerWidth) == 'number')   {
        width = window.innerWidth;
    } else if(document.body && document.body.clientWidth) {
        width = document.body.clientWidth;
    } else if(document.documentElement && document.documentElement.clientWidth){
        width = document.documentElement.clientWidth;
    }
    return width;
}

function setCompDescription(id, flag)
{
    if(positioned == false)
    {
      positionCompDescription();
      positioned = new Boolean(true);
    }
    setCompDescriptionColor(flag);
    document.getElementById("compDescription").innerHTML = compTitles[id];
}

