#
# CanDo - Web based competency tracking system.
# Copyright (C) 2006 Arlington Public Schools, Arlington, VA and The
# Shuttleworth Foundation.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software Foundation,
# Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#
import zope.interface
from zope.viewlet.interfaces import IViewletManager

class ITopMenu(IViewletManager):
    """Top Menu viewlet manager."""

class IBreadcrumbMenu(IViewletManager):
    """Breadcrumb Menu viewlet manager."""

class ISubMenu(IViewletManager):
    """Context-sensitive Sub Menu viewlet manager."""

class ISummaryManager(IViewletManager):
    """Viewlet Manager Interface for Summary View"""

class ISectionView(zope.interface.Interface):
    """Marks any view related to sections.

    Effectively any view that provides this interface will cause the top
    menu's 'Sections' item to be highlighted.
    """

class ICompetencyView(zope.interface.Interface):
    """Marks any view related to competencies.

    Effectively any view that provides this interface will cause the top
    menu's 'Competencies' item to be highlighted.
    """

class ISummaryView(zope.interface.Interface):
    """Marks any view related to summary.

    Effectively any view that provides this interface will cause the top
    menu's 'Summary' item to be highlighted.
    """

class ISkillDriversView(zope.interface.Interface):
    """Marks any view related to skill drivers.

    Effectively any view that provides this interface will cause the top
    menu's 'Skill Drivers' item to be highlighted.
    """

class IOption(zope.interface.Interface):
    """A fake object during traversal."""

