#
# CanDo - Web based competency tracking system.
# Copyright (C) 2006 Arlington Public Schools, Arlington, VA and The
# Shuttleworth Foundation.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software Foundation,
# Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#

import zope.interface

from z3c.pagelet.browser import BrowserPagelet

from cando.newskin import interfaces, PersonDistinguisher, CourseChooser, SectionChooser

class Go(BrowserPagelet):
    zope.interface.implements(interfaces.ISkillDriversView)

    def update(self):
        self.no_crumb_options = True

class GradeSkillDriversGo(BrowserPagelet, PersonDistinguisher):
    zope.interface.implements(interfaces.ISectionView)
    
    def update(self):
        self.rows = []
        if self.request.get('filter') is None:
            searchFilter = ''
        else:
            searchFilter = self.request.get('filter').lower()

        for skilldriver in self.context.values():
            if searchFilter == '' or searchFilter in skilldriver.title.lower():
                self.rows.append(skilldriver)

class CourseSkillDriversGo(BrowserPagelet, CourseChooser):
    zope.interface.implements(interfaces.ISkillDriversView)

    courseLink = '/skilldrivers'

class SectionSkillDriversGo(BrowserPagelet, SectionChooser):
    zope.interface.implements(interfaces.ISkillDriversView)

    sectionLink = '/skilldrivers'
