#
# CanDo - Web based competency tracking system.
# Copyright (C) 2006 Arlington Public Schools, Arlington, VA and The
# Shuttleworth Foundation.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software Foundation,
# Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#
from zope.interface import implements
import zope.location
from schooltool.traverser import traverser
from cando.newskin import interfaces

class Option(zope.location.Location):
    implements(interfaces.IOption)
    title = None
    def __init__(self, context):
        self.context = context

def OptionFactory(title, name=None):
    if name is None:
        name = str(title) + 'Option'
    return type(name, (Option,), {'title': title})

class OptionTraverserPlugin(traverser.NameTraverserPlugin):
    optionFactory = None
    locate = True

    def _traverse(self, request, name):
        option = self.optionFactory(self.context)
        if self.locate:
            zope.location.locate(
                option, self.context, self.traversalName)
        return option

def OptionTraverserFactory(name, factory, locate=True):
    return type(factory.__name__ + 'TraverserPlugin',
                (OptionTraverserPlugin,),
                {'traversalName': name, 'optionFactory': factory,
                 'locate': locate})
