#
# CanDo - Web based competency tracking system.
# Copyright (C) 2006 Arlington Public Schools, Arlington, VA and The
# Shuttleworth Foundation.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software Foundation,
# Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#
from cando.skilldriver import interfaces
from zope.security.proxy import removeSecurityProxy
from schooltool.table.batch import Batch
from zope.i18nmessageid import MessageFactory

_ = MessageFactory('cando')

class SectionDriverView(object):

    def moreDrivers(self):
        list = []
	parent = removeSecurityProxy(self.context)
        for course in parent.courses:
            skilldrivers = interfaces.ISkillDrivers(course)
            for skilldriver in skilldrivers:
                if skilldriver not in list:
                        list.append(skilldriver)
        return list

    def update(self):
	values = self.moreDrivers()

        if 'SEARCH' in self.request and 'CLEAR_SEARCH' not in self.request:
            searchstr = self.request['SEARCH'].lower()
            results = [item for item in values
                       if searchstr in item.title.lower()]
        else:
            self.request.form['SEARCH'] = ''
            results = values

        start = int(self.request.get('batch_start', 0))
        size = int(self.request.get('batch_size', 10))
        return Batch(results, start, size, sort_by='title')

    index_title = _(u"Assignment List")
