#
# CanDo - Web based competency tracking system.
# Copyright (C) 2006 Arlington Public Schools, Arlington, VA and The
# Shuttleworth Foundation.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software Foundation,
# Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#

from schooltool.app.browser import PathAdapterUtil

from schooltool.requirement.requirement import getRequirementKey

from cando.virginia.interfaces import ICompetencyReference
from cando.virginia.interfaces import ICompetencies

class CompetencyPath(PathAdapterUtil):

    def traverse(self, name, furtherPath=[]):
        if name == 'key':
            return hash(getRequirementKey(self.context))
        elif name == 'singleton':
            return ICompetencyReference.providedBy(self.context)
        elif name == 'group':
            return ICompetencies.providedBy(self.context)
