#
# CanDo - Web based competency tracking system.
# Copyright (C) 2006 Arlington Public Schools, Arlington, VA and The
# Shuttleworth Foundation.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software Foundation,
# Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#
"""
Functional tests for cando.virginia

$Id:$
"""
import unittest
import os

from schooltool.testing.functional import collect_ftests
from schooltool.testing.functional import ZCMLLayer

dir = os.path.abspath(os.path.dirname(__file__))
filename = os.path.join(dir, 'ftesting.zcml')

virginia_functional_layer = ZCMLLayer(filename,
                                  __name__,
                                  'virginia_functional_layer')

def test_suite():
    return collect_ftests(filenames=['README.txt'],
                          layer=virginia_functional_layer)

def addPerson(name, username=None, password=None, groups=[], browser=None):
    """Add a person.

    If username is not specified, it will be taken to be name.lower().

    If password is not specified, it will be taken to be username + 'pwd'.
    """
    if not username:
        username = name.lower()
    if not password:
        password = username + 'pwd'
    browser.getLink('Persons').click()
    browser.getLink('New Person').click()
    browser.getControl('Full name').value = name
    browser.getControl('First name').value = name
    browser.getControl('Username').value = username
    browser.getControl('Last name').value = name
    browser.getControl('Password').value = password
    browser.getControl('Confirm').value = password
    browser.getControl('Add').click()
    browser.getControl('Cancel').click()
    if groups:
        browser.getLink('Change Membership').click()
        for group in groups:
            browser.getControl(group).click()
            browser.getControl('Add').click()

    browser.open('http://localhost/persons')


if __name__ == '__main__':
    unittest.main(defaultTest='test_suite')
