from cando.virginia.interfaces import ICompetencies
from zope.interface import Interface
from zope.schema import Object, Text

class ICompetencyXMLImporter(Interface):
    
    def importFromXML(xmlstring):
        """Imports from an xml file or data (xmlstring)"""
    
    competencies = Object(
            schema=ICompetencies,
            title=u"Competencies",
            description=u"A container for 'VirginiaCompetency's (implements ICompetencies)",
            required=True)


class ICompetencyXMLExporter(Interface):
    
    def exportToXML(competencies):
        """Exports from data (competencies) to xml"""
    
    xml = Text(
        title=u"XML",
        description=u"XML Export Data",
        required=True)
